package it.sw.pa.comune.artegna.web.rest;

import static it.sw.pa.comune.artegna.domain.PrenotazioneAsserts.*;
import static it.sw.pa.comune.artegna.web.rest.TestUtil.createUpdateProxyForBean;
import static org.assertj.core.api.Assertions.assertThat;
import static org.hamcrest.Matchers.hasItem;
import static org.mockito.Mockito.*;
import static org.springframework.security.test.web.servlet.request.SecurityMockMvcRequestPostProcessors.csrf;
import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.*;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.*;

import com.fasterxml.jackson.databind.ObjectMapper;
import it.sw.pa.comune.artegna.IntegrationTest;
import it.sw.pa.comune.artegna.domain.Conferma;
import it.sw.pa.comune.artegna.domain.Prenotazione;
import it.sw.pa.comune.artegna.domain.Struttura;
import it.sw.pa.comune.artegna.domain.UtenteApp;
import it.sw.pa.comune.artegna.domain.enumeration.StatoPrenotazione;
import it.sw.pa.comune.artegna.repository.PrenotazioneRepository;
import it.sw.pa.comune.artegna.service.PrenotazioneService;
import it.sw.pa.comune.artegna.service.dto.PrenotazioneDTO;
import it.sw.pa.comune.artegna.service.mapper.PrenotazioneMapper;
import jakarta.persistence.EntityManager;
import java.time.Instant;
import java.time.temporal.ChronoUnit;
import java.util.ArrayList;
import java.util.Random;
import java.util.concurrent.atomic.AtomicLong;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.mockito.Mock;
import org.mockito.junit.jupiter.MockitoExtension;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.servlet.AutoConfigureMockMvc;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.http.MediaType;
import org.springframework.security.test.context.support.WithMockUser;
import org.springframework.test.web.servlet.MockMvc;
import org.springframework.transaction.annotation.Transactional;

/**
 * Integration tests for the {@link PrenotazioneResource} REST controller.
 */
@IntegrationTest
@ExtendWith(MockitoExtension.class)
@AutoConfigureMockMvc
@WithMockUser
class PrenotazioneResourceIT {

    private static final Instant DEFAULT_ORA_INIZIO = Instant.ofEpochMilli(0L);
    private static final Instant UPDATED_ORA_INIZIO = Instant.now().truncatedTo(ChronoUnit.MILLIS);

    private static final Instant DEFAULT_ORA_FINE = Instant.ofEpochMilli(0L);
    private static final Instant UPDATED_ORA_FINE = Instant.now().truncatedTo(ChronoUnit.MILLIS);

    private static final StatoPrenotazione DEFAULT_STATO = StatoPrenotazione.RICHIESTA;
    private static final StatoPrenotazione UPDATED_STATO = StatoPrenotazione.CONFERMATA;

    private static final String DEFAULT_MOTIVO_EVENTO = "AAAAAAAAAA";
    private static final String UPDATED_MOTIVO_EVENTO = "BBBBBBBBBB";

    private static final Integer DEFAULT_NUMERO_PARTECIPANTI = 1;
    private static final Integer UPDATED_NUMERO_PARTECIPANTI = 2;
    private static final Integer SMALLER_NUMERO_PARTECIPANTI = 1 - 1;

    private static final String DEFAULT_NOTE_UTENTE = "AAAAAAAAAA";
    private static final String UPDATED_NOTE_UTENTE = "BBBBBBBBBB";

    private static final String ENTITY_API_URL = "/api/prenotaziones";
    private static final String ENTITY_API_URL_ID = ENTITY_API_URL + "/{id}";

    private static Random random = new Random();
    private static AtomicLong longCount = new AtomicLong(random.nextInt() + (2L * Integer.MAX_VALUE));

    @Autowired
    private ObjectMapper om;

    @Autowired
    private PrenotazioneRepository prenotazioneRepository;

    @Mock
    private PrenotazioneRepository prenotazioneRepositoryMock;

    @Autowired
    private PrenotazioneMapper prenotazioneMapper;

    @Mock
    private PrenotazioneService prenotazioneServiceMock;

    @Autowired
    private EntityManager em;

    @Autowired
    private MockMvc restPrenotazioneMockMvc;

    private Prenotazione prenotazione;

    private Prenotazione insertedPrenotazione;

    /**
     * Create an entity for this test.
     *
     * This is a static method, as tests for other entities might also need it,
     * if they test an entity which requires the current entity.
     */
    public static Prenotazione createEntity() {
        return new Prenotazione()
            .oraInizio(DEFAULT_ORA_INIZIO)
            .oraFine(DEFAULT_ORA_FINE)
            .stato(DEFAULT_STATO)
            .motivoEvento(DEFAULT_MOTIVO_EVENTO)
            .numeroPartecipanti(DEFAULT_NUMERO_PARTECIPANTI)
            .noteUtente(DEFAULT_NOTE_UTENTE);
    }

    /**
     * Create an updated entity for this test.
     *
     * This is a static method, as tests for other entities might also need it,
     * if they test an entity which requires the current entity.
     */
    public static Prenotazione createUpdatedEntity() {
        return new Prenotazione()
            .oraInizio(UPDATED_ORA_INIZIO)
            .oraFine(UPDATED_ORA_FINE)
            .stato(UPDATED_STATO)
            .motivoEvento(UPDATED_MOTIVO_EVENTO)
            .numeroPartecipanti(UPDATED_NUMERO_PARTECIPANTI)
            .noteUtente(UPDATED_NOTE_UTENTE);
    }

    @BeforeEach
    void initTest() {
        prenotazione = createEntity();
    }

    @AfterEach
    void cleanup() {
        if (insertedPrenotazione != null) {
            prenotazioneRepository.delete(insertedPrenotazione);
            insertedPrenotazione = null;
        }
    }

    @Test
    @Transactional
    void createPrenotazione() throws Exception {
        long databaseSizeBeforeCreate = getRepositoryCount();
        // Create the Prenotazione
        PrenotazioneDTO prenotazioneDTO = prenotazioneMapper.toDto(prenotazione);
        var returnedPrenotazioneDTO = om.readValue(
            restPrenotazioneMockMvc
                .perform(
                    post(ENTITY_API_URL).with(csrf()).contentType(MediaType.APPLICATION_JSON).content(om.writeValueAsBytes(prenotazioneDTO))
                )
                .andExpect(status().isCreated())
                .andReturn()
                .getResponse()
                .getContentAsString(),
            PrenotazioneDTO.class
        );

        // Validate the Prenotazione in the database
        assertIncrementedRepositoryCount(databaseSizeBeforeCreate);
        var returnedPrenotazione = prenotazioneMapper.toEntity(returnedPrenotazioneDTO);
        assertPrenotazioneUpdatableFieldsEquals(returnedPrenotazione, getPersistedPrenotazione(returnedPrenotazione));

        insertedPrenotazione = returnedPrenotazione;
    }

    @Test
    @Transactional
    void createPrenotazioneWithExistingId() throws Exception {
        // Create the Prenotazione with an existing ID
        prenotazione.setId(1L);
        PrenotazioneDTO prenotazioneDTO = prenotazioneMapper.toDto(prenotazione);

        long databaseSizeBeforeCreate = getRepositoryCount();

        // An entity with an existing ID cannot be created, so this API call must fail
        restPrenotazioneMockMvc
            .perform(
                post(ENTITY_API_URL).with(csrf()).contentType(MediaType.APPLICATION_JSON).content(om.writeValueAsBytes(prenotazioneDTO))
            )
            .andExpect(status().isBadRequest());

        // Validate the Prenotazione in the database
        assertSameRepositoryCount(databaseSizeBeforeCreate);
    }

    @Test
    @Transactional
    void getAllPrenotaziones() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList
        restPrenotazioneMockMvc
            .perform(get(ENTITY_API_URL + "?sort=id,desc"))
            .andExpect(status().isOk())
            .andExpect(content().contentType(MediaType.APPLICATION_JSON_VALUE))
            .andExpect(jsonPath("$.[*].id").value(hasItem(prenotazione.getId().intValue())))
            .andExpect(jsonPath("$.[*].oraInizio").value(hasItem(DEFAULT_ORA_INIZIO.toString())))
            .andExpect(jsonPath("$.[*].oraFine").value(hasItem(DEFAULT_ORA_FINE.toString())))
            .andExpect(jsonPath("$.[*].stato").value(hasItem(DEFAULT_STATO.toString())))
            .andExpect(jsonPath("$.[*].motivoEvento").value(hasItem(DEFAULT_MOTIVO_EVENTO)))
            .andExpect(jsonPath("$.[*].numeroPartecipanti").value(hasItem(DEFAULT_NUMERO_PARTECIPANTI)))
            .andExpect(jsonPath("$.[*].noteUtente").value(hasItem(DEFAULT_NOTE_UTENTE)));
    }

    @SuppressWarnings({ "unchecked" })
    void getAllPrenotazionesWithEagerRelationshipsIsEnabled() throws Exception {
        when(prenotazioneServiceMock.findAllWithEagerRelationships(any())).thenReturn(new PageImpl(new ArrayList<>()));

        restPrenotazioneMockMvc.perform(get(ENTITY_API_URL + "?eagerload=true")).andExpect(status().isOk());

        verify(prenotazioneServiceMock, times(1)).findAllWithEagerRelationships(any());
    }

    @SuppressWarnings({ "unchecked" })
    void getAllPrenotazionesWithEagerRelationshipsIsNotEnabled() throws Exception {
        when(prenotazioneServiceMock.findAllWithEagerRelationships(any())).thenReturn(new PageImpl(new ArrayList<>()));

        restPrenotazioneMockMvc.perform(get(ENTITY_API_URL + "?eagerload=false")).andExpect(status().isOk());
        verify(prenotazioneRepositoryMock, times(1)).findAll(any(Pageable.class));
    }

    @Test
    @Transactional
    void getPrenotazione() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get the prenotazione
        restPrenotazioneMockMvc
            .perform(get(ENTITY_API_URL_ID, prenotazione.getId()))
            .andExpect(status().isOk())
            .andExpect(content().contentType(MediaType.APPLICATION_JSON_VALUE))
            .andExpect(jsonPath("$.id").value(prenotazione.getId().intValue()))
            .andExpect(jsonPath("$.oraInizio").value(DEFAULT_ORA_INIZIO.toString()))
            .andExpect(jsonPath("$.oraFine").value(DEFAULT_ORA_FINE.toString()))
            .andExpect(jsonPath("$.stato").value(DEFAULT_STATO.toString()))
            .andExpect(jsonPath("$.motivoEvento").value(DEFAULT_MOTIVO_EVENTO))
            .andExpect(jsonPath("$.numeroPartecipanti").value(DEFAULT_NUMERO_PARTECIPANTI))
            .andExpect(jsonPath("$.noteUtente").value(DEFAULT_NOTE_UTENTE));
    }

    @Test
    @Transactional
    void getPrenotazionesByIdFiltering() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        Long id = prenotazione.getId();

        defaultPrenotazioneFiltering("id.equals=" + id, "id.notEquals=" + id);

        defaultPrenotazioneFiltering("id.greaterThanOrEqual=" + id, "id.greaterThan=" + id);

        defaultPrenotazioneFiltering("id.lessThanOrEqual=" + id, "id.lessThan=" + id);
    }

    @Test
    @Transactional
    void getAllPrenotazionesByOraInizioIsEqualToSomething() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where oraInizio equals to
        defaultPrenotazioneFiltering("oraInizio.equals=" + DEFAULT_ORA_INIZIO, "oraInizio.equals=" + UPDATED_ORA_INIZIO);
    }

    @Test
    @Transactional
    void getAllPrenotazionesByOraInizioIsInShouldWork() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where oraInizio in
        defaultPrenotazioneFiltering("oraInizio.in=" + DEFAULT_ORA_INIZIO + "," + UPDATED_ORA_INIZIO, "oraInizio.in=" + UPDATED_ORA_INIZIO);
    }

    @Test
    @Transactional
    void getAllPrenotazionesByOraInizioIsNullOrNotNull() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where oraInizio is not null
        defaultPrenotazioneFiltering("oraInizio.specified=true", "oraInizio.specified=false");
    }

    @Test
    @Transactional
    void getAllPrenotazionesByOraFineIsEqualToSomething() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where oraFine equals to
        defaultPrenotazioneFiltering("oraFine.equals=" + DEFAULT_ORA_FINE, "oraFine.equals=" + UPDATED_ORA_FINE);
    }

    @Test
    @Transactional
    void getAllPrenotazionesByOraFineIsInShouldWork() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where oraFine in
        defaultPrenotazioneFiltering("oraFine.in=" + DEFAULT_ORA_FINE + "," + UPDATED_ORA_FINE, "oraFine.in=" + UPDATED_ORA_FINE);
    }

    @Test
    @Transactional
    void getAllPrenotazionesByOraFineIsNullOrNotNull() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where oraFine is not null
        defaultPrenotazioneFiltering("oraFine.specified=true", "oraFine.specified=false");
    }

    @Test
    @Transactional
    void getAllPrenotazionesByStatoIsEqualToSomething() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where stato equals to
        defaultPrenotazioneFiltering("stato.equals=" + DEFAULT_STATO, "stato.equals=" + UPDATED_STATO);
    }

    @Test
    @Transactional
    void getAllPrenotazionesByStatoIsInShouldWork() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where stato in
        defaultPrenotazioneFiltering("stato.in=" + DEFAULT_STATO + "," + UPDATED_STATO, "stato.in=" + UPDATED_STATO);
    }

    @Test
    @Transactional
    void getAllPrenotazionesByStatoIsNullOrNotNull() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where stato is not null
        defaultPrenotazioneFiltering("stato.specified=true", "stato.specified=false");
    }

    @Test
    @Transactional
    void getAllPrenotazionesByMotivoEventoIsEqualToSomething() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where motivoEvento equals to
        defaultPrenotazioneFiltering("motivoEvento.equals=" + DEFAULT_MOTIVO_EVENTO, "motivoEvento.equals=" + UPDATED_MOTIVO_EVENTO);
    }

    @Test
    @Transactional
    void getAllPrenotazionesByMotivoEventoIsInShouldWork() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where motivoEvento in
        defaultPrenotazioneFiltering(
            "motivoEvento.in=" + DEFAULT_MOTIVO_EVENTO + "," + UPDATED_MOTIVO_EVENTO,
            "motivoEvento.in=" + UPDATED_MOTIVO_EVENTO
        );
    }

    @Test
    @Transactional
    void getAllPrenotazionesByMotivoEventoIsNullOrNotNull() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where motivoEvento is not null
        defaultPrenotazioneFiltering("motivoEvento.specified=true", "motivoEvento.specified=false");
    }

    @Test
    @Transactional
    void getAllPrenotazionesByMotivoEventoContainsSomething() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where motivoEvento contains
        defaultPrenotazioneFiltering("motivoEvento.contains=" + DEFAULT_MOTIVO_EVENTO, "motivoEvento.contains=" + UPDATED_MOTIVO_EVENTO);
    }

    @Test
    @Transactional
    void getAllPrenotazionesByMotivoEventoNotContainsSomething() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where motivoEvento does not contain
        defaultPrenotazioneFiltering(
            "motivoEvento.doesNotContain=" + UPDATED_MOTIVO_EVENTO,
            "motivoEvento.doesNotContain=" + DEFAULT_MOTIVO_EVENTO
        );
    }

    @Test
    @Transactional
    void getAllPrenotazionesByNumeroPartecipantiIsEqualToSomething() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where numeroPartecipanti equals to
        defaultPrenotazioneFiltering(
            "numeroPartecipanti.equals=" + DEFAULT_NUMERO_PARTECIPANTI,
            "numeroPartecipanti.equals=" + UPDATED_NUMERO_PARTECIPANTI
        );
    }

    @Test
    @Transactional
    void getAllPrenotazionesByNumeroPartecipantiIsInShouldWork() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where numeroPartecipanti in
        defaultPrenotazioneFiltering(
            "numeroPartecipanti.in=" + DEFAULT_NUMERO_PARTECIPANTI + "," + UPDATED_NUMERO_PARTECIPANTI,
            "numeroPartecipanti.in=" + UPDATED_NUMERO_PARTECIPANTI
        );
    }

    @Test
    @Transactional
    void getAllPrenotazionesByNumeroPartecipantiIsNullOrNotNull() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where numeroPartecipanti is not null
        defaultPrenotazioneFiltering("numeroPartecipanti.specified=true", "numeroPartecipanti.specified=false");
    }

    @Test
    @Transactional
    void getAllPrenotazionesByNumeroPartecipantiIsGreaterThanOrEqualToSomething() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where numeroPartecipanti is greater than or equal to
        defaultPrenotazioneFiltering(
            "numeroPartecipanti.greaterThanOrEqual=" + DEFAULT_NUMERO_PARTECIPANTI,
            "numeroPartecipanti.greaterThanOrEqual=" + UPDATED_NUMERO_PARTECIPANTI
        );
    }

    @Test
    @Transactional
    void getAllPrenotazionesByNumeroPartecipantiIsLessThanOrEqualToSomething() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where numeroPartecipanti is less than or equal to
        defaultPrenotazioneFiltering(
            "numeroPartecipanti.lessThanOrEqual=" + DEFAULT_NUMERO_PARTECIPANTI,
            "numeroPartecipanti.lessThanOrEqual=" + SMALLER_NUMERO_PARTECIPANTI
        );
    }

    @Test
    @Transactional
    void getAllPrenotazionesByNumeroPartecipantiIsLessThanSomething() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where numeroPartecipanti is less than
        defaultPrenotazioneFiltering(
            "numeroPartecipanti.lessThan=" + UPDATED_NUMERO_PARTECIPANTI,
            "numeroPartecipanti.lessThan=" + DEFAULT_NUMERO_PARTECIPANTI
        );
    }

    @Test
    @Transactional
    void getAllPrenotazionesByNumeroPartecipantiIsGreaterThanSomething() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where numeroPartecipanti is greater than
        defaultPrenotazioneFiltering(
            "numeroPartecipanti.greaterThan=" + SMALLER_NUMERO_PARTECIPANTI,
            "numeroPartecipanti.greaterThan=" + DEFAULT_NUMERO_PARTECIPANTI
        );
    }

    @Test
    @Transactional
    void getAllPrenotazionesByNoteUtenteIsEqualToSomething() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where noteUtente equals to
        defaultPrenotazioneFiltering("noteUtente.equals=" + DEFAULT_NOTE_UTENTE, "noteUtente.equals=" + UPDATED_NOTE_UTENTE);
    }

    @Test
    @Transactional
    void getAllPrenotazionesByNoteUtenteIsInShouldWork() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where noteUtente in
        defaultPrenotazioneFiltering(
            "noteUtente.in=" + DEFAULT_NOTE_UTENTE + "," + UPDATED_NOTE_UTENTE,
            "noteUtente.in=" + UPDATED_NOTE_UTENTE
        );
    }

    @Test
    @Transactional
    void getAllPrenotazionesByNoteUtenteIsNullOrNotNull() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where noteUtente is not null
        defaultPrenotazioneFiltering("noteUtente.specified=true", "noteUtente.specified=false");
    }

    @Test
    @Transactional
    void getAllPrenotazionesByNoteUtenteContainsSomething() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where noteUtente contains
        defaultPrenotazioneFiltering("noteUtente.contains=" + DEFAULT_NOTE_UTENTE, "noteUtente.contains=" + UPDATED_NOTE_UTENTE);
    }

    @Test
    @Transactional
    void getAllPrenotazionesByNoteUtenteNotContainsSomething() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        // Get all the prenotazioneList where noteUtente does not contain
        defaultPrenotazioneFiltering(
            "noteUtente.doesNotContain=" + UPDATED_NOTE_UTENTE,
            "noteUtente.doesNotContain=" + DEFAULT_NOTE_UTENTE
        );
    }

    @Test
    @Transactional
    void getAllPrenotazionesByConfermaIsEqualToSomething() throws Exception {
        Conferma conferma;
        if (TestUtil.findAll(em, Conferma.class).isEmpty()) {
            prenotazioneRepository.saveAndFlush(prenotazione);
            conferma = ConfermaResourceIT.createEntity();
        } else {
            conferma = TestUtil.findAll(em, Conferma.class).get(0);
        }
        em.persist(conferma);
        em.flush();
        prenotazione.setConferma(conferma);
        prenotazioneRepository.saveAndFlush(prenotazione);
        Long confermaId = conferma.getId();
        // Get all the prenotazioneList where conferma equals to confermaId
        defaultPrenotazioneShouldBeFound("confermaId.equals=" + confermaId);

        // Get all the prenotazioneList where conferma equals to (confermaId + 1)
        defaultPrenotazioneShouldNotBeFound("confermaId.equals=" + (confermaId + 1));
    }

    @Test
    @Transactional
    void getAllPrenotazionesByUtenteIsEqualToSomething() throws Exception {
        UtenteApp utente;
        if (TestUtil.findAll(em, UtenteApp.class).isEmpty()) {
            prenotazioneRepository.saveAndFlush(prenotazione);
            utente = UtenteAppResourceIT.createEntity();
        } else {
            utente = TestUtil.findAll(em, UtenteApp.class).get(0);
        }
        em.persist(utente);
        em.flush();
        prenotazione.setUtente(utente);
        prenotazioneRepository.saveAndFlush(prenotazione);
        Long utenteId = utente.getId();
        // Get all the prenotazioneList where utente equals to utenteId
        defaultPrenotazioneShouldBeFound("utenteId.equals=" + utenteId);

        // Get all the prenotazioneList where utente equals to (utenteId + 1)
        defaultPrenotazioneShouldNotBeFound("utenteId.equals=" + (utenteId + 1));
    }

    @Test
    @Transactional
    void getAllPrenotazionesByStrutturaIsEqualToSomething() throws Exception {
        Struttura struttura;
        if (TestUtil.findAll(em, Struttura.class).isEmpty()) {
            prenotazioneRepository.saveAndFlush(prenotazione);
            struttura = StrutturaResourceIT.createEntity();
        } else {
            struttura = TestUtil.findAll(em, Struttura.class).get(0);
        }
        em.persist(struttura);
        em.flush();
        prenotazione.setStruttura(struttura);
        prenotazioneRepository.saveAndFlush(prenotazione);
        Long strutturaId = struttura.getId();
        // Get all the prenotazioneList where struttura equals to strutturaId
        defaultPrenotazioneShouldBeFound("strutturaId.equals=" + strutturaId);

        // Get all the prenotazioneList where struttura equals to (strutturaId + 1)
        defaultPrenotazioneShouldNotBeFound("strutturaId.equals=" + (strutturaId + 1));
    }

    private void defaultPrenotazioneFiltering(String shouldBeFound, String shouldNotBeFound) throws Exception {
        defaultPrenotazioneShouldBeFound(shouldBeFound);
        defaultPrenotazioneShouldNotBeFound(shouldNotBeFound);
    }

    /**
     * Executes the search, and checks that the default entity is returned.
     */
    private void defaultPrenotazioneShouldBeFound(String filter) throws Exception {
        restPrenotazioneMockMvc
            .perform(get(ENTITY_API_URL + "?sort=id,desc&" + filter))
            .andExpect(status().isOk())
            .andExpect(content().contentType(MediaType.APPLICATION_JSON_VALUE))
            .andExpect(jsonPath("$.[*].id").value(hasItem(prenotazione.getId().intValue())))
            .andExpect(jsonPath("$.[*].oraInizio").value(hasItem(DEFAULT_ORA_INIZIO.toString())))
            .andExpect(jsonPath("$.[*].oraFine").value(hasItem(DEFAULT_ORA_FINE.toString())))
            .andExpect(jsonPath("$.[*].stato").value(hasItem(DEFAULT_STATO.toString())))
            .andExpect(jsonPath("$.[*].motivoEvento").value(hasItem(DEFAULT_MOTIVO_EVENTO)))
            .andExpect(jsonPath("$.[*].numeroPartecipanti").value(hasItem(DEFAULT_NUMERO_PARTECIPANTI)))
            .andExpect(jsonPath("$.[*].noteUtente").value(hasItem(DEFAULT_NOTE_UTENTE)));

        // Check, that the count call also returns 1
        restPrenotazioneMockMvc
            .perform(get(ENTITY_API_URL + "/count?sort=id,desc&" + filter))
            .andExpect(status().isOk())
            .andExpect(content().contentType(MediaType.APPLICATION_JSON_VALUE))
            .andExpect(content().string("1"));
    }

    /**
     * Executes the search, and checks that the default entity is not returned.
     */
    private void defaultPrenotazioneShouldNotBeFound(String filter) throws Exception {
        restPrenotazioneMockMvc
            .perform(get(ENTITY_API_URL + "?sort=id,desc&" + filter))
            .andExpect(status().isOk())
            .andExpect(content().contentType(MediaType.APPLICATION_JSON_VALUE))
            .andExpect(jsonPath("$").isArray())
            .andExpect(jsonPath("$").isEmpty());

        // Check, that the count call also returns 0
        restPrenotazioneMockMvc
            .perform(get(ENTITY_API_URL + "/count?sort=id,desc&" + filter))
            .andExpect(status().isOk())
            .andExpect(content().contentType(MediaType.APPLICATION_JSON_VALUE))
            .andExpect(content().string("0"));
    }

    @Test
    @Transactional
    void getNonExistingPrenotazione() throws Exception {
        // Get the prenotazione
        restPrenotazioneMockMvc.perform(get(ENTITY_API_URL_ID, Long.MAX_VALUE)).andExpect(status().isNotFound());
    }

    @Test
    @Transactional
    void putExistingPrenotazione() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        long databaseSizeBeforeUpdate = getRepositoryCount();

        // Update the prenotazione
        Prenotazione updatedPrenotazione = prenotazioneRepository.findById(prenotazione.getId()).orElseThrow();
        // Disconnect from session so that the updates on updatedPrenotazione are not directly saved in db
        em.detach(updatedPrenotazione);
        updatedPrenotazione
            .oraInizio(UPDATED_ORA_INIZIO)
            .oraFine(UPDATED_ORA_FINE)
            .stato(UPDATED_STATO)
            .motivoEvento(UPDATED_MOTIVO_EVENTO)
            .numeroPartecipanti(UPDATED_NUMERO_PARTECIPANTI)
            .noteUtente(UPDATED_NOTE_UTENTE);
        PrenotazioneDTO prenotazioneDTO = prenotazioneMapper.toDto(updatedPrenotazione);

        restPrenotazioneMockMvc
            .perform(
                put(ENTITY_API_URL_ID, prenotazioneDTO.getId())
                    .with(csrf())
                    .contentType(MediaType.APPLICATION_JSON)
                    .content(om.writeValueAsBytes(prenotazioneDTO))
            )
            .andExpect(status().isOk());

        // Validate the Prenotazione in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
        assertPersistedPrenotazioneToMatchAllProperties(updatedPrenotazione);
    }

    @Test
    @Transactional
    void putNonExistingPrenotazione() throws Exception {
        long databaseSizeBeforeUpdate = getRepositoryCount();
        prenotazione.setId(longCount.incrementAndGet());

        // Create the Prenotazione
        PrenotazioneDTO prenotazioneDTO = prenotazioneMapper.toDto(prenotazione);

        // If the entity doesn't have an ID, it will throw BadRequestAlertException
        restPrenotazioneMockMvc
            .perform(
                put(ENTITY_API_URL_ID, prenotazioneDTO.getId())
                    .with(csrf())
                    .contentType(MediaType.APPLICATION_JSON)
                    .content(om.writeValueAsBytes(prenotazioneDTO))
            )
            .andExpect(status().isBadRequest());

        // Validate the Prenotazione in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
    }

    @Test
    @Transactional
    void putWithIdMismatchPrenotazione() throws Exception {
        long databaseSizeBeforeUpdate = getRepositoryCount();
        prenotazione.setId(longCount.incrementAndGet());

        // Create the Prenotazione
        PrenotazioneDTO prenotazioneDTO = prenotazioneMapper.toDto(prenotazione);

        // If url ID doesn't match entity ID, it will throw BadRequestAlertException
        restPrenotazioneMockMvc
            .perform(
                put(ENTITY_API_URL_ID, longCount.incrementAndGet())
                    .with(csrf())
                    .contentType(MediaType.APPLICATION_JSON)
                    .content(om.writeValueAsBytes(prenotazioneDTO))
            )
            .andExpect(status().isBadRequest());

        // Validate the Prenotazione in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
    }

    @Test
    @Transactional
    void putWithMissingIdPathParamPrenotazione() throws Exception {
        long databaseSizeBeforeUpdate = getRepositoryCount();
        prenotazione.setId(longCount.incrementAndGet());

        // Create the Prenotazione
        PrenotazioneDTO prenotazioneDTO = prenotazioneMapper.toDto(prenotazione);

        // If url ID doesn't match entity ID, it will throw BadRequestAlertException
        restPrenotazioneMockMvc
            .perform(
                put(ENTITY_API_URL).with(csrf()).contentType(MediaType.APPLICATION_JSON).content(om.writeValueAsBytes(prenotazioneDTO))
            )
            .andExpect(status().isMethodNotAllowed());

        // Validate the Prenotazione in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
    }

    @Test
    @Transactional
    void partialUpdatePrenotazioneWithPatch() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        long databaseSizeBeforeUpdate = getRepositoryCount();

        // Update the prenotazione using partial update
        Prenotazione partialUpdatedPrenotazione = new Prenotazione();
        partialUpdatedPrenotazione.setId(prenotazione.getId());

        partialUpdatedPrenotazione
            .oraFine(UPDATED_ORA_FINE)
            .stato(UPDATED_STATO)
            .motivoEvento(UPDATED_MOTIVO_EVENTO)
            .numeroPartecipanti(UPDATED_NUMERO_PARTECIPANTI);

        restPrenotazioneMockMvc
            .perform(
                patch(ENTITY_API_URL_ID, partialUpdatedPrenotazione.getId())
                    .with(csrf())
                    .contentType("application/merge-patch+json")
                    .content(om.writeValueAsBytes(partialUpdatedPrenotazione))
            )
            .andExpect(status().isOk());

        // Validate the Prenotazione in the database

        assertSameRepositoryCount(databaseSizeBeforeUpdate);
        assertPrenotazioneUpdatableFieldsEquals(
            createUpdateProxyForBean(partialUpdatedPrenotazione, prenotazione),
            getPersistedPrenotazione(prenotazione)
        );
    }

    @Test
    @Transactional
    void fullUpdatePrenotazioneWithPatch() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        long databaseSizeBeforeUpdate = getRepositoryCount();

        // Update the prenotazione using partial update
        Prenotazione partialUpdatedPrenotazione = new Prenotazione();
        partialUpdatedPrenotazione.setId(prenotazione.getId());

        partialUpdatedPrenotazione
            .oraInizio(UPDATED_ORA_INIZIO)
            .oraFine(UPDATED_ORA_FINE)
            .stato(UPDATED_STATO)
            .motivoEvento(UPDATED_MOTIVO_EVENTO)
            .numeroPartecipanti(UPDATED_NUMERO_PARTECIPANTI)
            .noteUtente(UPDATED_NOTE_UTENTE);

        restPrenotazioneMockMvc
            .perform(
                patch(ENTITY_API_URL_ID, partialUpdatedPrenotazione.getId())
                    .with(csrf())
                    .contentType("application/merge-patch+json")
                    .content(om.writeValueAsBytes(partialUpdatedPrenotazione))
            )
            .andExpect(status().isOk());

        // Validate the Prenotazione in the database

        assertSameRepositoryCount(databaseSizeBeforeUpdate);
        assertPrenotazioneUpdatableFieldsEquals(partialUpdatedPrenotazione, getPersistedPrenotazione(partialUpdatedPrenotazione));
    }

    @Test
    @Transactional
    void patchNonExistingPrenotazione() throws Exception {
        long databaseSizeBeforeUpdate = getRepositoryCount();
        prenotazione.setId(longCount.incrementAndGet());

        // Create the Prenotazione
        PrenotazioneDTO prenotazioneDTO = prenotazioneMapper.toDto(prenotazione);

        // If the entity doesn't have an ID, it will throw BadRequestAlertException
        restPrenotazioneMockMvc
            .perform(
                patch(ENTITY_API_URL_ID, prenotazioneDTO.getId())
                    .with(csrf())
                    .contentType("application/merge-patch+json")
                    .content(om.writeValueAsBytes(prenotazioneDTO))
            )
            .andExpect(status().isBadRequest());

        // Validate the Prenotazione in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
    }

    @Test
    @Transactional
    void patchWithIdMismatchPrenotazione() throws Exception {
        long databaseSizeBeforeUpdate = getRepositoryCount();
        prenotazione.setId(longCount.incrementAndGet());

        // Create the Prenotazione
        PrenotazioneDTO prenotazioneDTO = prenotazioneMapper.toDto(prenotazione);

        // If url ID doesn't match entity ID, it will throw BadRequestAlertException
        restPrenotazioneMockMvc
            .perform(
                patch(ENTITY_API_URL_ID, longCount.incrementAndGet())
                    .with(csrf())
                    .contentType("application/merge-patch+json")
                    .content(om.writeValueAsBytes(prenotazioneDTO))
            )
            .andExpect(status().isBadRequest());

        // Validate the Prenotazione in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
    }

    @Test
    @Transactional
    void patchWithMissingIdPathParamPrenotazione() throws Exception {
        long databaseSizeBeforeUpdate = getRepositoryCount();
        prenotazione.setId(longCount.incrementAndGet());

        // Create the Prenotazione
        PrenotazioneDTO prenotazioneDTO = prenotazioneMapper.toDto(prenotazione);

        // If url ID doesn't match entity ID, it will throw BadRequestAlertException
        restPrenotazioneMockMvc
            .perform(
                patch(ENTITY_API_URL)
                    .with(csrf())
                    .contentType("application/merge-patch+json")
                    .content(om.writeValueAsBytes(prenotazioneDTO))
            )
            .andExpect(status().isMethodNotAllowed());

        // Validate the Prenotazione in the database
        assertSameRepositoryCount(databaseSizeBeforeUpdate);
    }

    @Test
    @Transactional
    void deletePrenotazione() throws Exception {
        // Initialize the database
        insertedPrenotazione = prenotazioneRepository.saveAndFlush(prenotazione);

        long databaseSizeBeforeDelete = getRepositoryCount();

        // Delete the prenotazione
        restPrenotazioneMockMvc
            .perform(delete(ENTITY_API_URL_ID, prenotazione.getId()).with(csrf()).accept(MediaType.APPLICATION_JSON))
            .andExpect(status().isNoContent());

        // Validate the database contains one less item
        assertDecrementedRepositoryCount(databaseSizeBeforeDelete);
    }

    protected long getRepositoryCount() {
        return prenotazioneRepository.count();
    }

    protected void assertIncrementedRepositoryCount(long countBefore) {
        assertThat(countBefore + 1).isEqualTo(getRepositoryCount());
    }

    protected void assertDecrementedRepositoryCount(long countBefore) {
        assertThat(countBefore - 1).isEqualTo(getRepositoryCount());
    }

    protected void assertSameRepositoryCount(long countBefore) {
        assertThat(countBefore).isEqualTo(getRepositoryCount());
    }

    protected Prenotazione getPersistedPrenotazione(Prenotazione prenotazione) {
        return prenotazioneRepository.findById(prenotazione.getId()).orElseThrow();
    }

    protected void assertPersistedPrenotazioneToMatchAllProperties(Prenotazione expectedPrenotazione) {
        assertPrenotazioneAllPropertiesEquals(expectedPrenotazione, getPersistedPrenotazione(expectedPrenotazione));
    }

    protected void assertPersistedPrenotazioneToMatchUpdatableProperties(Prenotazione expectedPrenotazione) {
        assertPrenotazioneAllUpdatablePropertiesEquals(expectedPrenotazione, getPersistedPrenotazione(expectedPrenotazione));
    }
}
